//
//  M3XDocument.m
//  microMemex
//
//  Created by narita on 2017/05/10.
//  Copyright © 2017年 narita. All rights reserved.
//

#import "M3XDocument.h"
#import "M3XNote+CoreDataClass.h"
#import "M3XNote+CoreDataProperties.h"

@interface M3XDocument ()

@end

@implementation M3XDocument

#pragma mark - class methods

+ (BOOL)autosavesInPlace
{
    return YES;
}

#pragma mark - init methods

- (instancetype)init
{
    self = [super init];
    
    if (self)
    {

    }
    
    return self;
}

#pragma mark - dealloc

#pragma mark - NSCopying, hash, isEqual:

#pragma mark - NSCoding methods

#pragma mark - restorableState methods

#pragma mark - life cycle methods

#pragma mark - action methods

- (nullable instancetype)initWithType:(NSString *)typeName error:(NSError **)outError
{
    self = [super initWithType:typeName error:outError];
    
    if( self != nil )
    {
        // Rootの作成
        M3XNote* theRoot = nil;
        
        theRoot = [NSEntityDescription insertNewObjectForEntityForName:@"M3XNote" 
                                                inManagedObjectContext:self.managedObjectContext];
        
        NSAttributedString* theAttributedText = [[NSAttributedString alloc] initWithString:@"ROOT"];
        theRoot.memo = [theAttributedText RTFDFromRange:NSMakeRange(0, theAttributedText.length)
                                     documentAttributes:@{}];        
        theRoot.isHome = YES;
        
        // 最初のメモを作成
        M3XNote* theNewNote= [NSEntityDescription insertNewObjectForEntityForName:@"M3XNote" 
                                                           inManagedObjectContext:self.managedObjectContext];
        
        
        NSDateFormatter* theDateFormatter = [[NSDateFormatter alloc] init];
        [theDateFormatter setDateFormat:@"yy/MM/dd H:mm:ss"];
        
        NSString* theMemoString = [NSString stringWithFormat:@"最初のメモ : %@", [theDateFormatter stringFromDate:[NSDate date]]];
        
        NSAttributedString* theMemo = [[NSAttributedString alloc] initWithString:theMemoString];
        
        theNewNote.memo = [theMemo RTFDFromRange:NSMakeRange(0, theMemo.length)
                              documentAttributes:@{}];
        theNewNote.isHome = NO;
        
        [theRoot addLinksObject:theNewNote];        
        
        [self.managedObjectContext processPendingChanges];
    }
    
    return self;
}

#pragma mark - event handling methods

#pragma mark - drawing methods

#pragma mark - delegate/datasource methods

#pragma mark - accessor methods (in pairs)

#pragma mark - Utility methods

- (void)makeWindowControllers
{
    NSWindowController* theWindowController = nil;
    
    // Override to return the Storyboard file name of the document.
    theWindowController = [[NSStoryboard storyboardWithName:@"M3XWindowController" 
                                                     bundle:nil] instantiateControllerWithIdentifier:@"M3XWindowController"];
    
    [self addWindowController:theWindowController];
    
    // viewControllerへmodelObjectへのポインターを渡す
    theWindowController.contentViewController.representedObject = self.managedObjectContext;    

    // このプログラムのViewControllerはWindocControlerに対して動的に生成される構造ではないので、ここでモデルを設定する。
    // もしも、動的に生成される構造にする場合は、一旦WindowControllerへモデルを渡し、WindowControllerの中からViewControllerへ渡す手法に変更する事。
}

@end
