//
//  M3XNote+CoreDataClass.m
//  microMemex
//
//  Created by narita on 2017/05/11.
//  Copyright © 2017年 narita. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "M3XNote+CoreDataClass.h"

@implementation M3XNote

#pragma mark - class methods

+ (NSString*) pasteBoardRowsType
{
    return @"com.mindto01s.M3XNote";
}

#pragma mark - init methods

#pragma mark - dealloc

#pragma mark - NSCopying, hash, isEqual:

#pragma mark - NSCoding methods

- (void) wreiteToPasteboard:(NSPasteboard*)pasteboard
{    
    [pasteboard declareTypes:@[M3XNote.pasteBoardRowsType]
                       owner:self];
    
    [pasteboard setPropertyList:@{
                                  @"memo"              : self.memo,
                                  @"objectURL"         : [self.objectID.URIRepresentation pasteboardPropertyListForType:(id)kUTTypeURL],
                                  @"objectContextHash" : @([self.managedObjectContext hash])
                                  }
                        forType:M3XNote.pasteBoardRowsType];
}

+ (instancetype) readFromPasteboard:(NSPasteboard*)pasteboard 
             inManagedObjectContext:(NSManagedObjectContext *)context
{
    NSDictionary* thePasteObject = [pasteboard propertyListForType:M3XNote.pasteBoardRowsType]; 
    
    M3XNote* theResult = nil;
    
    if( [@([context hash]) isEqualToValue:[thePasteObject objectForKey:@"objectContextHash"] ] )
    {
        // 同じcontextなので、objectURL検索して返す
        NSURL* theURL = [NSURL URLWithString:[thePasteObject objectForKey:@"objectURL"]];
        
        NSManagedObjectID* theManagedObjectID = [context.persistentStoreCoordinator managedObjectIDForURIRepresentation:theURL];
        theResult = [context objectWithID:theManagedObjectID];
    }
    else
    {
        // 異なるcontextなので、新規作成してmemoコピー。
        theResult = [NSEntityDescription insertNewObjectForEntityForName:@"M3XNote" 
                                                  inManagedObjectContext:context];
        
        theResult.memo = [thePasteObject objectForKey:@"memo"];
        theResult.isHome = NO;        
    }
    
    return theResult;
}

#pragma mark - restorableState methods

#pragma mark - life cycle methods

#pragma mark - action methods

#pragma mark - event handling methods

#pragma mark - drawing methods

#pragma mark - delegate/datasource methods

#pragma mark - accessor methods (in pairs)

#pragma mark - Utility methods

- (M3XNote*) noteFromIndexPath:(NSIndexPath*)inIndexPath
{
    M3XNote* theResultNode = self;
    
    for(NSUInteger i = 0; i < inIndexPath.length; i++)
    {
        theResultNode = theResultNode.sortedLinks[[inIndexPath indexAtPosition:i]];
    }
    
    return theResultNode;
 }


@end
